\documentclass[a4paper,12pt]{article}
\usepackage{ragged2e}
\usepackage[french]{babel}
%\usepackage[autolanguage]{numprint}
%\usepackage{sidenotes}
\usepackage{layout}
\usepackage{caption}
\captionsetup[figure]{font=small}
%% \usepackage{geometry}
%%  \geometry{
%%  a4paper,
%%  total={100mm,257mm},
%%  inner=50mm,
%%  outer=50mm,
%%  top=20mm,
%%  bottom=20mm,
%% }
%% \textheight=257mm

\usepackage{enumitem}

\usepackage{pgfplots}
\pgfplotsset{compat = newest}

\usepackage[utf8]{inputenc}

%\marginparwidth=60mm
%\textwidth=100mm
% \voffset=0pt
% \hoffset=00pt
\usepackage{graphicx}
%\usepackage{kpfonts-otf}
%\usepackage{scrextend} 
%\changefontsizes[16pt]{12pt}
\usepackage{amsthm}
\usepackage[framemethod=tikz]{mdframed}
\usepackage[no-math]{fontspec}
%\setromanfont[Ligatures=TeX]{Times New Roman}
%\usepackage{chngcntr}
\usepackage{lipsum}
\usepackage{tikz}
\usepackage{amsbsy}
\usepackage[sfdefault]{FiraSans}
\usepackage[mathrm=sym]{unicode-math}
\usepackage[edges]{forest}
\forestset{%
  label tree/.style={
    for tree={tier/.option=level},
    level label/.style={
      before typesetting nodes={
        for nodewalk={current,tempcounta/.option=level,group={root,tree breadth-first},ancestors}{if={>OR={level}{tempcounta}}{before drawing tree={label me=##1}}{}},
      }
    },
    before drawing tree={
      tikz+={\coordinate (a) at (current bounding box.north);},
    },
  },
  label me/.style={tikz+={\node [anchor=base west] at (.parent |- a) {#1};}},
}
%\usepackage[varg]{newtxmath}

\setmonofont{Fira Code}
% Normal font
\setsansfont{Fira Sans}[
	Numbers=OldStyle,
	BoldFont=Fira Sans SemiBold,
	ItalicFont=Fira Sans Italic,
	BoldItalicFont=Fira Sans SemiBold Italic
]

\setmainfont{Fira Sans}[
	Numbers=OldStyle,
	BoldFont=Fira Sans SemiBold,
	ItalicFont=Fira Sans Italic,
	BoldItalicFont=Fira Sans SemiBold Italic
        ]
%\setmathfont{TeX Gyre Pagella Math}
%\setmathfont{KpMath-Sans.otf}[version=sf]
\setmathfont{Fira Math Regular}
\setmathfont{TeX Gyre DejaVu Math}[range={\vdots,\ddots,\top}]
\DeclareMathAlphabet{\mathcal}{OMS}{cmbrs}{m}{n}
\setmathfont{Fira Math}[range=]

\usepackage{minted}
\usepackage{xcolor} % to access the named colour LightGray
\definecolor{LightGray}{gray}{0.9}

\usepackage[
backend=biber,       % Sortier-Compiler
style=iso-authoryear,% Zitationsstil
sorting=nyt,        % Sortiervorschrift
abbreviate=false,   % Abkürzungen
block=ragged        % Flattersatz
]{biblatex}
\addbibresource{bibliographie.bib}

\usepackage{./macros}

\usetikzlibrary{decorations.markings,bending,arrows.meta,calc}

\makeatletter
\newenvironment{code}
 {\RecustomVerbatimEnvironment{Verbatim}{BVerbatim}{}%
  \def\FV@BProcessLine##1{%
    \hbox{%
      \hbox to\z@{\hss\theFancyVerbLine\kern\FV@NumberSep}%
      \FancyVerbFormatLine{##1}%
    }%
  }%
  \VerbatimEnvironment
  \setbox\z@=\hbox\bgroup
  \begin{minted}[fontsize=\scriptsize]{python}}
 {\end{minted}\egroup
  \leavevmode\vbox{\hrule\kern2mm\box\z@\kern2mm\hrule}}
\makeatother

\setminted[python]{ %
    linenos=true,             % Line numbers
    autogobble=true,          % Automatically remove common white space
    frame=lines,
    framesep=2mm,
    fontsize=\small
}



\usepackage{xcolor}
\newmdenv[skipabove=5pt,
skipbelow=5pt,
roundcorner=10pt,
rightline=false,
leftline=true,
topline=false,
bottomline=false,
linecolor=orange,
backgroundcolor=orange!15,
innerleftmargin=5pt,
innerrightmargin=5pt,
innertopmargin=7pt,
leftmargin=0cm,
rightmargin=0cm,
linewidth=2.5pt,
innerbottommargin=5pt]{dBox}    
\newenvironment{definition}{\begin{dBox}\begin{definitionT}}{\end{definitionT}\end{dBox}}
\newtheorem{definitionT}{Définition}[section]

\newmdenv[skipabove=5pt,
skipbelow=5pt,
roundcorner=0pt,
rightline=false,
leftline=true,
topline=false,
bottomline=false,
linecolor=cyan,
backgroundcolor=cyan!9,
innerleftmargin=5pt,
innerrightmargin=5pt,
innertopmargin=7pt,
leftmargin=0cm,
rightmargin=0cm,
linewidth=2.5pt,
innerbottommargin=5pt]{thmBox}    
\newenvironment{theorem}{\begin{thmBox}\begin{theoremT}}{\end{theoremT}\end{thmBox}}
\newtheorem{theoremT}{Théorème}[section]

\newmdenv[skipabove=5pt,
skipbelow=5pt,
roundcorner=0pt,
rightline=false,
leftline=true,
topline=false,
bottomline=false,
linecolor=black,
backgroundcolor=black!9,
innerleftmargin=5pt,
innerrightmargin=5pt,
innertopmargin=7pt,
leftmargin=0cm,
rightmargin=0cm,
linewidth=2.5pt,
innerbottommargin=5pt]{prfBox}    
\newenvironment{proofj}{\begin{prfBox}\begin{proofT}}{\end{proofT}\end{prfBox}}
\newtheorem{proofT}{Démonstration}[section]

\newmdenv[skipabove=5pt,
skipbelow=5pt,
roundcorner=0pt,
rightline=false,
leftline=true,
topline=false,
bottomline=false,
linecolor=magenta,
backgroundcolor=magenta!9,
innerleftmargin=5pt,
innerrightmargin=5pt,
innertopmargin=7pt,
leftmargin=0cm,
rightmargin=0cm,
linewidth=2.5pt,
innerbottommargin=5pt]{prtsBox}    
\newenvironment{properties}{\begin{prtsBox}\begin{propertiesT}}{\end{propertiesT}\end{prtsBox}}
\newtheorem{propertiesT}{Propriétés}[section]
